#include "sensors/SimulatedMagnetometer.h"

const double simulated_data[100][4] = {
    // Time	Mag_xAxis	Mag_yAxis	Mag_zAxis
    {0, 27.555, -2.4169, -16.0849},
    {0.1, 27.3488680951906, -4.14232356556852, -16.0849},
    {0.2, 27.0348027025189, -5.85139927247137, -16.0849},
    {0.3, 26.6140432946068, -7.53738217969581, -16.0849},
    {0.4, 26.0882504166107, -9.19361848295937, -16.0849},
    {0.5, 25.4594991328081, -10.8135717742354, -16.0849},
    {0.6, 24.7302708372672, -12.3908488379696, -16.0849},
    {0.7, 23.9034434609175, -13.9192248821807, -16.0849},
    {0.8, 22.9822801136722, -15.3926681048708, -16.0849},
    {0.9, 21.9704162064233, -16.8053634987921, -16.0849},
    {1, 20.871845103736, -18.1517358006239, -16.0849},
    {1.1, 19.6909023638633, -19.42647149399, -16.0849},
    {1.2, 18.432248628278, -20.6245397794798, -16.0849},
    {1.3, 17.1008512282502, -21.7412124289161, -16.0849},
    {1.4, 15.7019645810603, -22.7720824455105, -16.0849},
    {1.5, 14.2411094532143, -23.7130814562674, -16.0849},
    {1.6, 12.7240511725004, -24.5604957679928, -16.0849},
    {1.7, 11.1567768748747, -25.3109810235451, -16.0849},
    {1.8, 9.54547187597045, -25.9615754004848, -16.0849},
    {1.9, 7.89649526048299, -26.5097113000344, -16.0849},
    {2, 6.21635478576793, -26.9532254802178, -16.0849},
    {2.1, 4.5116811986958, -27.2903675931882, -16.0849},
    {2.2, 2.78920206712347, -27.5198070930513, -16.0849},
    {2.3, 1.05571522925745, -27.640638486922, -16.0849},
    {2.4, -0.681938034308039, -27.6523849084914, -16.0849},
    {2.5, -2.41689999999998, -27.555, -16.0849},
    {2.6, -4.1423235655685, -27.3488680951906, -16.0849},
    {2.7, -5.85139927247134, -27.0348027025189, -16.0849},
    {2.8, -7.53738217969579, -26.6140432946068, -16.0849},
    {2.9, -9.19361848295934, -26.0882504166107, -16.0849},
    {3, -10.8135717742354, -25.4594991328082, -16.0849},
    {3.1, -12.3908488379696, -24.7302708372672, -16.0849},
    {3.2, -13.9192248821807, -23.9034434609176, -16.0849},
    {3.3, -15.3926681048708, -22.9822801136722, -16.0849},
    {3.4, -16.8053634987921, -21.9704162064233, -16.0849},
    {3.5, -18.1517358006239, -20.871845103736, -16.0849},
    {3.6, -19.4264714939899, -19.6909023638633, -16.0849},
    {3.7, -20.6245397794798, -18.432248628278, -16.0849},
    {3.8, -21.741212428916, -17.1008512282502, -16.0849},
    {3.9, -22.7720824455105, -15.7019645810604, -16.0849},
    {4, -23.7130814562673, -14.2411094532143, -16.0849},
    {4.1, -24.5604957679928, -12.7240511725005, -16.0849},
    {4.2, -25.3109810235451, -11.1567768748748, -16.0849},
    {4.3, -25.9615754004848, -9.54547187597047, -16.0849},
    {4.4, -26.5097113000344, -7.89649526048301, -16.0849},
    {4.5, -26.9532254802178, -6.21635478576794, -16.0849},
    {4.6, -27.2903675931882, -4.51168119869581, -16.0849},
    {4.7, -27.5198070930513, -2.7892020671235, -16.0849},
    {4.8, -27.640638486922, -1.05571522925746, -16.0849},
    {4.9, -27.6523849084914, 0.681938034308037, -16.0849},
    {5, -27.555, 2.41689999999998, -16.0849},
    {5.1, -27.3488680951906, 4.1423235655685, -16.0849},
    {5.2, -27.0348027025189, 5.85139927247134, -16.0849},
    {5.3, -26.6140432946068, 7.53738217969579, -16.0849},
    {5.4, -26.0882504166107, 9.19361848295934, -16.0849},
    {5.5, -25.4594991328082, 10.8135717742354, -16.0849},
    {5.6, -24.7302708372672, 12.3908488379696, -16.0849},
    {5.7, -23.9034434609176, 13.9192248821807, -16.0849},
    {5.8, -22.9822801136722, 15.3926681048708, -16.0849},
    {5.9, -21.9704162064233, 16.8053634987921, -16.0849},
    {6, -20.871845103736, 18.1517358006239, -16.0849},
    {6.1, -19.6909023638633, 19.4264714939899, -16.0849},
    {6.2, -18.432248628278, 20.6245397794798, -16.0849},
    {6.3, -17.1008512282502, 21.741212428916, -16.0849},
    {6.4, -15.7019645810604, 22.7720824455105, -16.0849},
    {6.5, -14.2411094532143, 23.7130814562673, -16.0849},
    {6.6, -12.7240511725004, 24.5604957679928, -16.0849},
    {6.7, -11.1567768748748, 25.3109810235451, -16.0849},
    {6.8, -9.54547187597047, 25.9615754004848, -16.0849},
    {6.9, -7.89649526048301, 26.5097113000344, -16.0849},
    {7, -6.21635478576793, 26.9532254802178, -16.0849},
    {7.1, -4.51168119869581, 27.2903675931882, -16.0849},
    {7.2, -2.7892020671235, 27.5198070930513, -16.0849},
    {7.3, -1.05571522925747, 27.640638486922, -16.0849},
    {7.4, 0.68193803430802, 27.6523849084914, -16.0849},
    {7.5, 2.41689999999997, 27.555, -16.0849},
    {7.6, 4.14232356556849, 27.3488680951906, -16.0849},
    {7.7, 5.85139927247134, 27.0348027025189, -16.0849},
    {7.8, 7.53738217969579, 26.6140432946068, -16.0849},
    {7.9, 9.19361848295934, 26.0882504166107, -16.0849},
    {8, 10.8135717742354, 25.4594991328082, -16.0849},
    {8.1, 12.3908488379696, 24.7302708372672, -16.0849},
    {8.2, 13.9192248821807, 23.9034434609176, -16.0849},
    {8.3, 15.3926681048708, 22.9822801136722, -16.0849},
    {8.4, 16.8053634987921, 21.9704162064233, -16.0849},
    {8.5, 18.1517358006239, 20.871845103736, -16.0849},
    {8.6, 19.4264714939899, 19.6909023638633, -16.0849},
    {8.7, 20.6245397794798, 18.432248628278, -16.0849},
    {8.8, 21.741212428916, 17.1008512282502, -16.0849},
    {8.9, 22.7720824455105, 15.7019645810604, -16.0849},
    {9, 23.7130814562673, 14.2411094532143, -16.0849},
    {9.1, 24.5604957679928, 12.7240511725005, -16.0849},
    {9.2, 25.3109810235451, 11.1567768748748, -16.0849},
    {9.3, 25.9615754004848, 9.54547187597048, -16.0849},
    {9.4, 26.5097113000344, 7.89649526048301, -16.0849},
    {9.5, 26.9532254802178, 6.21635478576795, -16.0849},
    {9.6, 27.2903675931882, 4.51168119869582, -16.0849},
    {9.7, 27.5198070930513, 2.78920206712351, -16.0849},
    {9.8, 27.640638486922, 1.05571522925747, -16.0849},
    {9.9, 27.6523849084914, -0.681938034308027, -16.0849}};

SimulatedMagnetometer::SimulatedMagnetometer(const uint32_t id) : Magnetometer(id), counter(0) {
}

void SimulatedMagnetometer::init(int mode) {
    this->currMode = mode;
}

bool SimulatedMagnetometer::reset() {
    return true;
}

MagnetometerMeasurement SimulatedMagnetometer::readMeasurement() {
    MagnetometerMeasurement measurement(static_cast<float>(simulated_data[counter][1]), static_cast<float>(simulated_data[counter][2]),
                                        static_cast<float>(simulated_data[counter][3]));
    counter++;
    if (counter >= 100)
        counter = 0;
    return measurement;
}
